<?php
/* 
 * Display an RGB Pallet.

 There appears to be patterns in the static.
 1. Create a tag cloud of the hexadecimal values and how often
 they appear in the code.
 2. Adjust the dimensions of the square and see if other patterns
 emerge.

 */
//Extend the Execution Time
//(This takes a while to process)
  ini_set('max_execution_time',300);

// Convert Decimal to Hexadecimal for HTML
  function convertToHexadecimal($integer)
  {
    $conversionFactors = array(
      0=>'0',1=>'1',2=>'2',3=>'3',4=>'4',5=>'5',6=>'6',7=>'7',8=>'8'
      ,9=>'9',10=>'A',11=>'B',12=>'C',13=>'D',14=>'E',15=>'F'
    );
    //If the Number is less than 16.
    if ($integer < 16)
    {
      //return convertToCharacter($integer);
      return "0".$conversionFactors[$integer];
    }
    else
    {
      //Find the Sixteenth's Place by Dividing Integer by 16
      //Take the Whole Number part and discard the fraction.
      $firstDigitInteger = (floor($integer/16)); //This is Rounding Up
      $firstDigit = $conversionFactors[$firstDigitInteger];
      $secondDigit = $conversionFactors[($integer % 16)];
      //Return the two digits concatenated.
      return $firstDigit . $secondDigit;
    }
  }
?>
<html>
  <head>
    <title>RGB Pallet Renderer</title>
  </head>
<body>
<?php
// Make the sliding bar dyanmic: user chooses R, G, or B
  $z = 0;
  if (isset($_GET['z']))
  {
    $z = $_GET['z'];
  }
?>
<b>Set Variable:</b>
<a href="rgb.php?variable=Random">Random</a> |
<a href="rgb.php?variable=Red&z=<?php echo $z ?>">Red</a> |
<a href="rgb.php?variable=Green&z=<?php echo $z ?>">Green</a> |
<a href="rgb.php?variable=Blue&z=<?php echo $z ?>">Blue</a>
<table border="1">
<tr><td>
<table border="0" cellspacing="0" cellpadding="0">
<?php
// Put RGB into a Cube, like X,Y,Z coordinates.
// Display as a Square, use AJAX to return new color tables
  $variable = "Random";
  if (isset($_GET['variable']))
  {
    $variable = $_GET['variable'];
  }
  for ($x=0;$x<256;$x++)
  {
    echo "<tr>";
    for ($y=0;$y<256;$y++)
    {
      switch ($variable)
      {
        case 'Blue':
          //Blue is Variable
          $r = convertToHexadecimal($x);
          $g = convertToHexadecimal($y);
          $b = convertToHexadecimal($z);
          break;
        case 'Red':
          $r = convertToHexadecimal($z);
          $g = convertToHexadecimal($x);
          $b = convertToHexadecimal($y);
          break;
        case 'Green':
          $r = convertToHexadecimal($y);
          $g = convertToHexadecimal($z);
          $b = convertToHexadecimal($x);
          break;
        default:
          $r = convertToHexadecimal(rand(0,255));
          $g = convertToHexadecimal(rand(0,255));
          $b = convertToHexadecimal(rand(0,255));
          break;
      }
      //echo "<td bgcolor=\"#{$r}{$g}{$b}\"><a href=\"rgb.php?variable={$variable}&z={$y}\"><img src=\"pixel.gif\" width=\"2\" height=\"2\" border=\"0\" alt=\"{$r}{$g}{$b}\"></a></td>\n";
      echo "<td bgcolor=\"#{$r}{$g}{$b}\"><img src=\"pixel.gif\" width=\"4\" height=\"4\" border=\"0\" title=\"{$r}{$g}{$b}\"></td>";
    }
    echo "</tr>\n";
  }
?>
</table>
</td></tr>
</table>
</body>
</html>
